<?php

/*
Plugin Name: Ping.mk Share Button
Version: 1.0.0
Plugin URI: http://www.ping.mk
Author: Boris Kuzmanov
Author URI: http://kuzmanov.wp.mk/
Description: Ping.mk rocks :)
*/ 

require_once 'pingmk1.php';
require_once 'pingmk-var.php';
require_once 'pingmk-admin.php';


function pingmk_stylesheet_table()
{
	echo '<link rel="stylesheet" href="'. get_bloginfo('wpurl') . '/wp-content/plugins/pingmk/';
	echo 'pingmk-style.css?ver=' . DD_VERSION . '" type="text/css" media="screen" />';
}

function pingmk_stylesheet_ul()
{
	echo '<link rel="stylesheet" href="'. get_bloginfo('wpurl') . '/wp-content/plugins/pingmk/';
	echo 'pingmk-style-ul.css?ver=' . DD_VERSION . '" type="text/css" media="screen" />';
}

add_action(PING_WP_ADMIN_MENU, PING_ADMIN_MENU);
add_filter(PING_WP_THE_CONTENT, PING_CONTENT_HOOK);

$html_output = get_Option(PING_OUTPUT_HTML);
if($html_output==PING_OUTPUT_HTML_UL){
	add_action(PING_WP_HEAD, 'pingmk_stylesheet_ul');	
}else if($html_output==PING_OUTPUT_HTML_TABLE){
	add_action(PING_WP_HEAD, 'pingmk_stylesheet_table');	
}else{
	add_action(PING_WP_HEAD, 'pingmk_stylesheet_ul');	
}

register_activation_hook( __FILE__, 'pingmk_initialIt');


function pingmk_DataInitialer($type=PING_FUNC_TYPE_RESET){
	$pingmk_golemo = new PING_Golemo();
	$pingmk_malo = new PING_Malo();

	
	if(get_option(PING_Golemo_OPTIONS)==PING_EMPTY_VALUE || $type==PING_FUNC_TYPE_RESET)
		update_option(PING_Golemo_OPTIONS, $pingmk_golemo->wp_options);
	
	if(get_option(PING_Malo_OPTIONS)==PING_EMPTY_VALUE || $type==PING_FUNC_TYPE_RESET)
		update_option(PING_Malo_OPTIONS, $pingmk_malo->wp_options);
		
	if(get_option(PING_DISPLAY_HOME)==PING_EMPTY_VALUE || $type==PING_FUNC_TYPE_RESET)
		update_option(PING_DISPLAY_HOME, PING_DISPLAY_OFF);
		
	if(get_option(PING_DISPLAY_PAGE)==PING_EMPTY_VALUE || $type==PING_FUNC_TYPE_RESET)
		update_option(PING_DISPLAY_PAGE, PING_DISPLAY_OFF);
		
	if(get_option(PING_DISPLAY_POST)==PING_EMPTY_VALUE || $type==PING_FUNC_TYPE_RESET)
		update_option(PING_DISPLAY_POST, PING_DISPLAY_ON);
		
	if(get_option(PING_DISPLAY_CATEGORY)==PING_EMPTY_VALUE || $type==PING_FUNC_TYPE_RESET)
		update_option(PING_DISPLAY_CATEGORY, PING_DISPLAY_OFF);
		
	if(get_option(PING_DISPLAY_ARCHIVE)==PING_EMPTY_VALUE || $type==PING_FUNC_TYPE_RESET)
		update_option(PING_DISPLAY_ARCHIVE, PING_DISPLAY_OFF);
	

	
	if(get_option(PING_OUTPUT_HTML)==PING_EMPTY_VALUE || $type==PING_FUNC_TYPE_RESET)
		update_option(PING_OUTPUT_HTML, PING_OUTPUT_HTML_UL);
		

}


function pingmk_resetIt(){
	pingmk_DataInitialer(PING_FUNC_TYPE_RESET);	
}

function pingmk_initialIt(){
	pingmk_DataInitialer(PING_FUNC_TYPE_INITIAL);
}

//dodava meni vo admin panelot
function pingmk_admin_menu() {
	add_submenu_page(PING_WP_OPTIONS_GENERAL, PING_OPTIONS, PING_NAME, 8, PING_NAME , PING_MENU);
}

function pingmk_menu(){
	
	$pingmk_golemo = new PING_Golemo();
	$pingmk_malo = new PING_Malo();
	
	if (isset($_POST[PING_FORM_SAVE])) {

	
	    
	    foreach(array_keys($pingmk_golemo->wp_options) as $key){
	    	$pingmk_golemo->wp_options[$key] = $_POST[$key];
	    }
	    

	    foreach(array_keys($pingmk_malo->wp_options) as $key){
	    	$pingmk_malo->wp_options[$key] = $_POST[$key];
	    }
	    
		update_option(PING_Golemo_OPTIONS, $pingmk_golemo->wp_options);
		update_option(PING_Malo_OPTIONS, $pingmk_malo->wp_options);
		
		
	    update_option(PING_DISPLAY_HOME, $_POST[PING_DISPLAY_HOME]);
		update_option(PING_DISPLAY_PAGE, $_POST[PING_DISPLAY_PAGE]);
		update_option(PING_DISPLAY_POST, $_POST[PING_DISPLAY_POST]);
		update_option(PING_DISPLAY_CATEGORY, $_POST[PING_DISPLAY_CATEGORY]);
		update_option(PING_DISPLAY_ARCHIVE, $_POST[PING_DISPLAY_ARCHIVE]);
	
		update_option(PING_LINE_UP, $_POST[PING_LINE_UP]);
		
		update_option(PING_OUTPUT_HTML, $_POST[PING_OUTPUT_HTML]);
		
		
		echo '<div id="message" class="updated fade"><p>Settings updated.</p></div>';
		
  	}else if(isset($_POST[PING_FORM_CLEAR])){
	
        pingmk_resetIt();
		echo "<div id='message' class='error fade'><p>Settings Reseted.</p></div>";
			
  	}

  	
    $pingmk_golemo->wp_options = get_option(PING_Golemo_OPTIONS);
  	$pingmk_malo->wp_options = get_option(PING_Malo_OPTIONS);
  
  	$pingmk_buttons = array($pingmk_golemo,$pingmk_malo);
  	
  	print_pingmk_menu_form($pingmk_buttons);
  
}


function pingmk_isDisplay(){

    $pingmk_display_home = get_option(PING_DISPLAY_HOME);
	$pingmk_display_page = get_option(PING_DISPLAY_PAGE);
	$pingmk_display_post = get_option(PING_DISPLAY_POST);
	$pingmk_display_category = get_option(PING_DISPLAY_CATEGORY);
	$pingmk_display_archive = get_option(PING_DISPLAY_ARCHIVE);
	
	$pingmk_display_feed = PING_DISPLAY_OFF;

	if(is_home() && ($pingmk_display_home==PING_DISPLAY_ON)){
		return true;
	}else if(is_feed() && ($pingmk_display_feed==PING_DISPLAY_ON)){
		return true;
	}else if(is_single() && ($pingmk_display_post==PING_DISPLAY_ON)){
		return true;
	}else if(is_category() && ($pingmk_display_category==PING_DISPLAY_ON)){
		return true;
	}else if(is_page() && ($pingmk_display_page==PING_DISPLAY_ON)){
		return true;
	}else if(is_archive() && ($pingmk_display_archive==PING_DISPLAY_ON)){
		return true;
	}else{
		return false;
	}
}

function pingmk_content_hook($content = ''){

    global $wp_query;
    $post = $wp_query->post; //zima sodrzina od postot
    $id = $post->ID; //id brojot na postot
    $comments = $post->comment_count; //komentari na postot
    $postlink = get_permalink($id); //link na postot
    $title = trim(urlencode($post->post_title)); // naslov na postot
    $link = split(PING_DASH,$postlink); //oddelni gi linkovite so '#'

  
    if(pingmk_isDisplay()==false){
    	return $content;
    }
	
    $pingmk_line_up = get_option(PING_LINE_UP);	 
    $pingmk_html_output = get_option(PING_OUTPUT_HTML);
    
	$pingmk_golemo = new PING_Golemo();
  	$pingmk_malo = new PING_Malo();
	
	$pingmk_golemo->wp_options = get_option(PING_Golemo_OPTIONS);
	$pingmk_malo->wp_options = get_option(PING_Malo_OPTIONS);
	
    $pingmk_golemo->construstURL($link[0],$title,$pingmk_golemo->get_button_design());
    $pingmk_malo->construstURL($link[0],$title,$pingmk_malo->get_button_design());
    
	$pingmk_left_float = '';
	$pingmk_right_float = '';
	$pingmk_before_content = '';
	$pingmk_after_content = '';
	
	$pingmk_sorting_data = array();
	$pingmk_sorting_data[$pingmk_golemo->get_button_weight().'-'.$pingmk_golemo->name] = $pingmk_golemo;
	$pingmk_sorting_data[$pingmk_malo->get_button_weight().'-'.$pingmk_malo->name] = $pingmk_malo;
	
	krsort($pingmk_sorting_data,SORT_NUMERIC);
	
	if($pingmk_html_output==PING_OUTPUT_HTML_UL){
		$content = generatepingmkContentUL($content,$pingmk_sorting_data, $pingmk_line_up);
	}else{
		$content = generatepingmkContentTable($content,$pingmk_sorting_data, $pingmk_line_up);
	}
	
	
	
    return $content;
}

function generatepingmkContentUL($content,$pingmk_all_data, $pingmk_line_up){
	
	$pingmk_before_content = '';
	$pingmk_after_content = ''; 
	$pingmk_left_float = ''; 
	$pingmk_right_float = '';
	
	foreach($pingmk_all_data as $obj){
		if($obj->get_append_type() == PING_SELECT_LEFT_FLOAT){
			$pingmk_left_float .= generateList($obj->finalURL,$pingmk_line_up);
		}else if($obj->get_append_type() == PING_SELECT_RIGHT_FLOAT){
			$pingmk_right_float .= generateList($obj->finalURL,$pingmk_line_up);
		}else if($obj->get_append_type() == PING_SELECT_BEFORE_CONTENT){
			$pingmk_before_content .= generateList($obj->finalURL,$pingmk_line_up);
		}else if($obj->get_append_type() == PING_SELECT_AFTER_CONTENT){
			$pingmk_after_content .= generateList($obj->finalURL,$pingmk_line_up);
		}
	}
	
	if($pingmk_before_content!=''){
		if($pingmk_line_up==PING_LINE_UP_HORIZONTAL){
			$pingmk_before_content = "<div id='ping_before'><ul>" . $pingmk_before_content. "</ul><div style=\"clear:both\"></div></div>";
		}else if($pingmk_line_up==PING_LINE_UP_VERTICAL){
			$pingmk_before_content = "<div id='ping_before'><ul>" . $pingmk_before_content. "</ul></div>";
		}else{
			$pingmk_before_content = "<div id='ping_before'><ul>" . $pingmk_before_content. "</ul><div style=\"clear:both\"></div></div>";
		}
	}
		
	if($pingmk_after_content!=''){
		if($pingmk_line_up==PING_LINE_UP_HORIZONTAL){
			$pingmk_after_content = "<div id='ping_after'><ul>" . $pingmk_after_content. "</ul></div><div style=\"clear:both\"></div>";
		}else if($pingmk_line_up==PING_LINE_UP_VERTICAL){
			$pingmk_after_content = "<div id='ping_after'><ul>" . $pingmk_after_content. "</ul></div><div style=\"clear:both\"></div>";
		}else{
			$pingmk_after_content = "<div id='ping_after'><ul>" . $pingmk_after_content. "</ul></div><div style=\"clear:both\"></div>";
		}
	}
	
	if($pingmk_left_float!=''){
		if($pingmk_line_up==PING_LINE_UP_HORIZONTAL){
			$pingmk_left_float = "<div id='ping_left'><ul>" . $pingmk_left_float. "</ul></div>";
		}else if($ping_line_up==PING_LINE_UP_VERTICAL){
			$pingmk_left_float = "<div id='ping_left'><ul>" . $pingmk_left_float. "</ul></div>";
		}else{
			$pingmk_left_float = "<div id='ping_left'><ul>" . $pingmk_left_float. "</ul></div>";
		}
	}
		
	if($pingmk_right_float!=''){
		if($pingmk_line_up==PING_LINE_UP_HORIZONTAL){
			$pingmk_right_float = "<div id='ping_right'><ul>" . $pingmk_right_float. "</ul></div>";
		}else if($pingmk_line_up==PING_LINE_UP_VERTICAL){
			$pingmk_right_float = "<div id='ping_right'><ul>" . $pingmk_right_float. "</ul></div>";
		}else{
			$pingmk_right_float = "<div id='ping_right'><ul>" . $pingmk_right_float. "</ul></div>";
		}
	}	
	
	$content = $pingmk_left_float . $pingmk_right_float . $pingmk_before_content . $content . $pingmk_after_content . PING_AUTHOR_SITE;
	
	return $content;
}

function generateList($link, $pingmk_line_up){
	
	if($pingmk_line_up==PING_LINE_UP_HORIZONTAL){
		return "<li class='li_horizontal'>" .$link. "</li>" ;
	}else if($pingmk_line_up==PING_LINE_UP_VERTICAL){
		return "<li class='li_vertical'>" .$link. "</li>" ;
	}else{
		return "<li class='li_horizontal'>" .$link. "</li>" ;
	}

}


function generatepingmkContentTable($content,$pingmk_all_data, $pingmk_line_up){
	
	$pingmk_before_content = '';
	$pingmk_after_content = ''; 
	$pingmk_left_float = ''; 
	$pingmk_right_float = '';
	
	foreach($pingmk_all_data as $obj){
		if($obj->get_append_type() == PING_SELECT_LEFT_FLOAT){
			$pingmk_left_float .= generateTableCells($obj->finalURL,$pingmk_line_up);
		}else if($obj->get_append_type() == PING_SELECT_RIGHT_FLOAT){
			$pingmk_right_float .= generateTableCells($obj->finalURL,$pingmk_line_up);
		}else if($obj->get_append_type() == PING_SELECT_BEFORE_CONTENT){
			$pingmk_before_content .= generateTableCells($obj->finalURL,$pingmk_line_up);
		}else if($obj->get_append_type() == PING_SELECT_AFTER_CONTENT){
			$pingmk_after_content .= generateTableCells($obj->finalURL,$pingmk_line_up);
		}
	}
	
	if($pingmk_before_content!=''){
		if($pingmk_line_up==PING_LINE_UP_HORIZONTAL){
			$pingmk_before_content = "<div class='ping_before'><table><tr>" . $pingmk_before_content. "</tr></table></div>";	
		}else if($pingmk_line_up==PING_LINE_UP_VERTICAL){
			$pingmk_before_content = "<div class='ping_before'><table>" . $pingmk_before_content. "</table></div>";	
		}else{
			$pingmk_before_content = "<div class='ping_before'><table><tr>" . $pingmk_before_content. "</tr></table></div>";
		}
	}
		
	if($pingmk_after_content!=''){
		if($pingmk_line_up==PING_LINE_UP_HORIZONTAL){
			$pingmk_after_content = "<div class='ping_after'><table><tr>" . $pingmk_after_content. "</tr></table></div>";	
		}else if($pingmk_line_up==PING_LINE_UP_VERTICAL){
			$pingmk_after_content = "<div class='ping_after'><table>" . $pingmk_after_content. "</table></div>";
		}else{
			$pingmk_after_content = "<div class='ping_after'><table><tr>" . $pingmk_after_content. "</tr></table></div>";
		}
	}
	
	if($pingmk_left_float!=''){
		if($pingmk_line_up==PING_LINE_UP_HORIZONTAL){
			$pingmk_left_float = "<div class='ping_left'><table><tr>" . $pingmk_left_float. "</tr></table></div>";
		}else if($pingmk_line_up==PING_LINE_UP_VERTICAL){
			$pingmk_left_float = "<div class='ping_left'><table>" . $pingmk_left_float. "</table></div>";
		}else{
			$pingmk_left_float = "<div class='ping_left'><table><tr>" . $pingmk_left_float. "</tr></table></div>";
		}
	}
		
	if($pingmk_right_float!=''){
		if($pingmk_line_up==PING_LINE_UP_HORIZONTAL){
			$pingmk_right_float = "<div class='ping_right'><table><tr>" . $pingmk_right_float. "</tr></table></div>";
		}else if($pingmk_line_up==PING_LINE_UP_VERTICAL){
			$pingmk_right_float = "<div class='ping_right'><table>" . $pingmk_right_float. "</table></div>";
		}else{
			$pingmk_right_float = "<div class='ping_right'><table><tr>" . $pingmk_right_float. "</tr></table></div>";
		}
	}	
	
	$content = $pingmk_left_float . $pingmk_right_float . $pingmk_before_content . $content . $pingmk_after_content . PING_AUTHOR_SITE;
	
	return $content;
}


function generateTableCells($link, $pingmk_line_up){
	
	if($pingmk_line_up==PING_LINE_UP_HORIZONTAL){
		return "<td>" .$link. "</td>" ;
	}else if($pingmk_line_up==PING_LINE_UP_VERTICAL){
		return "<tr><td>" .$link. "</td></tr>" ;
	}else{
		return "<td>" .$link. "</td>" ;
	}
	
}
	

?>